/* Copyright(c) 2002,2003 Device Drivers Limited, All rights reserved. */
/*                              info@devdrv.com http://www.devdrv.com/ */
#include <stdio.h>
#include <pthread.h>
#include <fcntl.h>
#include <termio.h>

#include <sys/time.h>
#include <unistd.h>

int fdr;
int fdw;

/* #define DEBUG 1 */

#define BUFFER_SIZE 1024
#define LOOP_COUNT 200

char rbuf[BUFFER_SIZE]; /* ¦Хåե */
char wbuf[BUFFER_SIZE] = "abcdefghij"; /* ߡǡƤǧ뤿 */

int t;

struct timezone tz;
struct timeval s_tv;
struct timeval e_tv;
#define s_getime(msg) \
 {\
  gettimeofday(&s_tv, &tz); \
 }
#define e_getime(msg) \
 {\
  gettimeofday(&e_tv, &tz); \
  e_tv.tv_sec -= s_tv.tv_sec; \
  e_tv.tv_usec -= s_tv.tv_usec; \
  if (e_tv.tv_usec < 0) { \
    e_tv.tv_usec += 1000000L; \
    e_tv.tv_sec--; \
  } \
  t = e_tv.tv_sec * 1000 + (e_tv.tv_usec + 500) / 1000; \
 }

/* 񤭹¦å */
void *threadA (char *arg)
{
  int i, len;

#ifdef DEBUG
  printf("Thread-A Start.\n");
#endif
  for(i = 0; i < LOOP_COUNT; i++) {
    len = write(fdw, wbuf, BUFFER_SIZE);
  }
  close(fdw);
}

/* ɤ߹¦å */
void *threadB (char *arg)
{
  int i, len, total;

  total = 0;
#ifdef DEBUG
  printf("Thread-B Start.\n");
#endif
  s_getime("loop start");

  for(i = 0;; i++) {       /* ΩޤǤ̵¥롼 */
    len = read(fdr, rbuf, BUFFER_SIZE); /* ºݤϥХȿlen¸ */
#ifdef DEBUG
    printf("%d(%d): %s\n", i, len, rbuf); /* ưǧΤвɽ */
#endif
    if ((total+=len) >= (LOOP_COUNT * BUFFER_SIZE)) /* ϥХȿ׻ */
      break;               /* ϤХȤȰפнλ */
  }

  e_getime("loop end");

  close(fdr);
}

int main()
{
  int s;
  struct termios tio;
  pthread_t thA, thB;
  long kbps;

  /* ɤ߹¦ǥץΥץ */
  if ((fdr = open("/dev/ttyS0", O_RDONLY)) < 0) {
    fprintf(stderr, "th: open error\n");
    exit(1);
  }
  /* 񤭹߹¦ǥץΥץ */
  if ((fdw = open("/dev/ttyS0", O_WRONLY)) < 0) {
    fprintf(stderr, "th: open error\n");
    exit(1);
  }
  printf("Program Start.\n");
#if 0
  bzero(&tio, sizeof(tio)); /* ȥӥ塼깽¤Τν */

  /* 115200bps, եͭ, ӥåȡDTR/DSR̵ǽ */
  tio.c_cflag = B115200 | CRTSCTS | CS8 | CLOCAL | CREAD;
  tio.c_cc[VMIN] = 1; /* ϥǡХåեʤ */
  tcsetattr(fdr, TCSANOW, &tio);  /* ¦ȥӥ塼ȤΥå */
  tcsetattr(fdw, TCSANOW, &tio);  /* ¦ȥӥ塼ȤΥå */
#endif
  if ((s = pthread_create(&thB, NULL, (void*) threadB, NULL)) != 0) {
    printf("thB: create error!\n"); /* ɤ߹¦åɤεưȥ顼 */
    exit(2);
  }
  if ((s = pthread_create(&thA, NULL, (void*) threadA, NULL)) != 0) {
    printf("thA: create error!\n"); /* 񤭹¦åɤεưȥ顼 */
    exit(3);
  }

  if ((s = pthread_join(thA, NULL)) != 0) { /* åɤνλԤ */
    printf("thA: join error!\n");
    exit(4);
  }
#ifdef DEBUG
  printf("Thread-A Exit.\n");
#endif
  if ((s = pthread_join(thB, NULL)) != 0) { /* åɤνλԤ */
    printf("thB: join error!\n");
    exit(5);
  }
#ifdef DEBUG
  printf("Thread-B Exit.\n");
#endif
  kbps = (BUFFER_SIZE * LOOP_COUNT * 8 / 1024 * 1000 + t / 2) / t;
  printf("performance for Loopback (%d bytes * %d times) in %d ms = %ld Kbps\n",
	 BUFFER_SIZE, LOOP_COUNT, t, kbps);

  exit(0);
}

/*
ѥ륳ޥɡ
cc -g -lpthread -o perform perform.c
*/
